<?php
/*
 * Copyright (c) 2000-2001
 *   Peter Johnson <wakefield@users.sourceforge.net>.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the author nor the names of any co-contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL Peter Johnson OR
 * OTHER CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: list2.php3,v 1.8 2001/05/18 03:28:18 wakefield Exp $
 */

require('../config.php3');
require('../alumni.php3');

function printcontent($str) {
  global $sep;
  if($str=='') {
    echo $sep;
    return;
  }

  if(strchr($str, '"')) {
    /* have to preprocess: " -> "" and quotes around the whole thing */
    $str = ereg_replace('"', '""', $str);
    echo "\"$str\"".$sep;
    return;
  }

  if(strchr($str, $sep))
    echo "\"$str\"".$sep;
  else
    echo "$str$sep";

  return;
}

$db = mysql_connect($dbhost, $dblogin, $dbpass);
mysql_select_db($dbname, $db);

if($format=='CSV') {
  header('Content-type: text/csv');
  header('Content-Disposition: attachment; filename="alumni.csv"');
  if(isset($dispname))
    echo 'Last Name'.$sep.'First Name'.$sep.'Middle Name'.$sep.'Nickname'.$sep;
  if(isset($dispyear))
    echo 'School'.$sep.'Year'.$sep;
  if(isset($dispemail))
    echo 'Email'.$sep;
  if(isset($dispocc))
    echo 'Occupation'.$sep;
  if(isset($dispwhere))
    echo 'Where (Occ)'.$sep;
  if(isset($dispwhat))
    echo 'What (Occ)'.$sep;
  if(isset($dispadd))
    echo 'Address 1'.$sep.'Address 2'.$sep;
  if(isset($dispphone))
    echo 'Phone'.$sep;
  if(isset($dispapprove))
    echo 'Approval Status'.$sep;
  echo "\r\n";
} else {
  page_header('$Id: list2.php3,v 1.8 2001/05/18 03:28:18 wakefield Exp $');
?>
<font size="+1"><b><u>List/Export</u></b></font><br />
<form method="POST" action="list2.php3">
<table border="0" cellpadding="0" cellspacing="8"><tr>
<td><table border="0" cellpadding="0" cellspacing="8"><tr>
<td valign="top"></td>
<td><i>Criteria</i></td>
<td><i>Search for / in:</i></td>
</tr><tr>
<td><?php checkbox_input('chkname', isset($chkname)) ?></td><td>Name:</td>
<td><?php text_input('srchname', 0, 0, $srchname) ?></td>
</tr><tr>
<td valign="top"><?php checkbox_input('chkschool', isset($chkschool)) ?></td><td valign="top">School:</td>
<td valign="top"><?php school_select_multiple($db, 'schools[]', 4, $schools, 0) ?></td>
</tr><tr>
<td><?php checkbox_input('chkyear', isset($chkyear)) ?></td><td>Year Graduated:</td>
<td><?php text_input('srchyear', 0, 0, $srchyear) ?></td>
</tr><tr>
<td valign="top"><?php checkbox_input('chkocc', isset($chkocc)) ?></td><td valign="top">Occupation:</td>
<td valign="top"><?php occtype_select_multiple($db, 'occtypes[]', 3, $occtypes) ?></td>
</tr><tr>
<td><?php checkbox_input('chkwhere', isset($chkwhere)) ?></td>
<td align="center"><i>Where?</i></td>
<td><?php text_input('srchwhere', 0, 0, $srchwhere) ?></td>
</tr><tr>
<td><?php checkbox_input('chkwhat', isset($chkwhat)) ?></td>
<td align=center><i>What?</i></td>
<td><?php text_input('srchwhat', 0, 0, $srchwhat) ?></td>
</tr><tr>
<td><?php checkbox_input('chkapprove', isset($chkapprove)) ?></td><td>Approval Status:</td>
<td><?php approve_select('approve', $approve) ?></td>
</tr></table>
</td><td valign="top">
<table border="0" cellpadding="0" cellspacing="8"><tr>
<td colspan="2"><i>Display in output</i></td>
</tr><tr>
<td><?php checkbox_input('dispname', isset($dispname)) ?>Name</td>
<td><?php checkbox_input('dispyear', isset($dispyear)) ?>School / Year</td>
</tr><tr>
<td><?php checkbox_input('dispemail', isset($dispemail)) ?>E-mail</td>
<td><?php checkbox_input('dispocc', isset($dispocc)) ?>Occupation</td>
</tr><tr>
<td><?php checkbox_input('dispwhere', isset($dispwhere)) ?>Where (Occ.)</td>
<td><?php checkbox_input('dispwhat', isset($dispwhat)) ?>What (Occ.)</td>
</tr><tr>
<td><?php checkbox_input('dispadd', isset($dispadd)) ?>Address</td>
<td><?php checkbox_input('dispphone', isset($dispphone)) ?>Phone</td>
</tr><tr>
<td><?php checkbox_input('dispapprove', isset($dispapprove)) ?>Approval Status</td>
</tr><tr>
<td colspan="2"><br /><i>Output Format:</i><select name="format">
<option value="Web"<?php if($format=='Web') echo ' selected'; ?>>Standard (Web)</option>
<option value="CSV"<?php if($format=='CSV') echo ' selected'; ?>>Text File Export (CSV)</option>
</select></td>
</tr><tr>
<td colspan="2"><br /><i>Click on a name to view/edit its details.</i></td>
</tr><tr>
<td colspan="2"><i>Look at <a href="export.php3">this document</a> for
instructions on opening exported data in MS Excel or MS Access.</i></td>
</tr><tr>
<td colspan="2"><i>Caution: This search can return very long results!</i></td>
</tr><tr>
<td colspan="2"><i>By default, the search only includes pending and approved
entries.</i></td>
</tr></table></td>
</tr></table>
<input type="submit" value="Search">
</form>
<hr />
<?php
}

$anychecked = 0;

$query_string_data = 'SELECT AlumID, Name_Last, Name_First';

if(isset($dispname))
  $query_string_data = $query_string_data . ', Name_Middle, Name_Nick';
if(isset($dispyear))
  $query_string_data = $query_string_data . ', Schools.ShortName AS sShortName, Schools.LongName, Year';
if(isset($dispemail))
  $query_string_data = $query_string_data . ', Public_EMail, EMail';
if(isset($dispocc) || isset($dispwhere) || isset($dispwhat))
{
  $query_string_data = $query_string_data . ', Public_Occupation';
  if(isset($dispocc))
    $query_string_data = $query_string_data . ', Occupations.ShortName AS oShortName';
  if(isset($dispwhere))
    $query_string_data = $query_string_data . ', Occupation_Where';
  if(isset($dispwhat))
    $query_string_data = $query_string_data . ', Occupation_What';
}
if(isset($dispadd))
  $query_string_data = $query_string_data . ', Public_Address, Address_1, Address_2';
if(isset($dispphone))
  $query_string_data = $query_string_data . ', Public_Phone, Phone';
if(isset($dispapprove))
  $query_string_data = $query_string_data . ', Alumni.Approved AS Approved';

$query_string_data = $query_string_data . ' FROM Alumni LEFT JOIN Schools ON SchoolID = School LEFT JOIN Occupations ON OccupationID = Occupation WHERE ';

$query_string = '';

if (isset($chkname)) {
  $srchnames = explode(' ', addslashes($srchname));
  $query_string = $query_string . "(((Name_First LIKE '%$srchnames[0]%') OR (Name_Middle LIKE '%$srchnames[0]%') OR (Name_Last LIKE '%$srchnames[0]%') OR (Name_Nick LIKE '%$srchnames[0]%'))";
  for($i=1,$n=count($srchnames); $i<$n; $i++) {
    $query_string = $query_string . " AND ((Name_First LIKE '%$srchnames[$i]%') OR (Name_Middle LIKE '%$srchnames[$i]%') OR (Name_Last LIKE '%$srchnames[$i]%') OR (Name_Nick LIKE '%$srchnames[$i]%'))";
  }
  $query_string = $query_string . ')';
  $anychecked = 1;
}

if (isset($schools) && (isset($chkschool) && !empty($schools[0]))) {
  if ($anychecked)
    $query_string = $query_string . ' AND ';
  $query_string = $query_string.'((School='.intval($schools[0]).')';
  for($i=1,$n=count($schools); $i<$n; $i++) {
    $query_string = $query_string . ' OR (School='.intval($schools[$i]).')';
  }
  $query_string = $query_string . ')';
  $anychecked = 1;
}

if (isset($chkyear)) {
  if ($anychecked)
    $query_string = $query_string . ' AND ';
  $srchyears = explode(' ', $srchyear);
  $query_string = $query_string . '((Year=' . intval($srchyears[0]) . ')';
  for($i=1,$n=count($srchyears); $i<$n; $i++) {
    $query_string = $query_string . ' OR (Year=' . intval($srchyears[$i]) . ')';
  }
  $query_string = $query_string . ')';
  $anychecked = 1;
}

if (isset($occtypes) && (isset($chkocc) && !empty($occtypes[0]))) {
  if ($anychecked)
    $query_string = $query_string.' AND ';
  $query_string = $query_string . '((Occupation='.intval($occtypes[0]).')';
  for($i=1,$n=count($occtypes); $i<$n; $i++) {
    $query_string = $query_string.' OR (Occupation='.intval($occtypes[$i]).')';
  }
  $query_string = $query_string.')';
  $anychecked = 1;
}

if (isset($chkwhere)) {
  if ($anychecked)
    $query_string = $query_string . ' AND ';
  $srchwheres = explode(' ', addslashes($srchwhere));
  $query_string = $query_string . "((Occupation_Where LIKE '%$srchwheres[0]%')";
  for($i=1,$n=count($srchwheres); $i<$n; $i++) {
    $query_string = $query_string . " AND (Occupation_Where LIKE '%$srchwheres[$i]%')";
  }
  $query_string = $query_string . ')';
  $anychecked = 1;
}

if (isset($chkwhat)) {
  if ($anychecked)
    $query_string = $query_string . ' AND ';
  $srchwhats = explode(' ', addslashes($srchwhat));
  $query_string = $query_string . "((Occupation_What LIKE '%$srchwhats[0]%')";
  for($i=1,$n=count($srchwhats); $i<$n; $i++) {
    $query_string = $query_string . "((Occupation_What LIKE '%$srchwhats[$i]%')";
  }
  $query_string = $query_string . ')';
  $anychecked = 1;
}

if (isset($chkapprove)) {
  if ($anychecked)
    $query_string = $query_string.' AND ';
  $query_string = $query_string.'(Alumni.Approved='.intval($approve).')';
  $anychecked = 1;
} else {
  $query_string = $query_string.' AND (Alumni.Approved=0 OR Alumni.Approved=1)';
}

$query_string = $query_string . ' ORDER BY Name_Last, Name_First, Year';

$result = mysql_query($query_string_data . $query_string,$db);

if ($anychecked && $myrow = mysql_fetch_array($result)) {
  do {
    if($format=='CSV') {
      if(isset($dispname)) {
        printcontent($myrow['Name_Last']);
        printcontent($myrow['Name_First']);
        printcontent($myrow['Name_Middle']);
        printcontent($myrow['Name_Nick']);
      }
      if(isset($dispyear)) {
        echo $myrow['sShortName'] . $sep;
        echo $myrow['Year'] . $sep;
      }
      if(isset($dispemail)) {
        printcontent($myrow['EMail']);
      }
      if(isset($dispocc)) {
        echo $myrow['oShortName'] . $sep;
      }
      if(isset($dispwhere)) {
        printcontent($myrow['Occupation_Where']);
      }
      if(isset($dispwhat)) {
        printcontent($myrow['Occupation_What']);
      }
      if(isset($dispadd)) {
        printcontent($myrow['Address_1']);
        printcontent($myrow['Address_2']);
      }
      if(isset($dispphone)) {
        printcontent($myrow['Phone']);
      }
      if(isset($dispapprove)) {
        approve_print($myrow['Approved']);
	echo $sep;
      }
      echo "\r\n";
    } else {
      /* name */
      echo '<table border="1" width="95%">'."\n";
      echo '<tr><td width="50%"><a href="view.php3?id='.$myrow['AlumID'].'">';
      echo '<b>'.htmlspecialchars($myrow['Name_Last']).', ';
      echo htmlspecialchars($myrow['Name_First']).'</b></a></td>';
      if(isset($dispname)) {
        echo '<td>'.htmlspecialchars($myrow['Name_Middle']).'</td>';
        if(!empty($myrow['Name_Nick']))
          echo '<td>A.K.A. '.htmlspecialchars($myrow['Name_Nick']).'</td>';
        else
          echo '<td></td>';
      }

      /* year / school */
      if(isset($dispyear)) {
        echo '<tr><td colspan="2"><b>School</b>: '.htmlspecialchars($myrow['LongName']).'</td>';
        echo '<td><b>Year</b>: '.$myrow['Year'].'</td>';
      }

      echo '</tr></table>'."\n";
      echo '<table border="1" width="95%">'."\n";

      /* email */
      if(isset($dispemail)) {
        echo '<td width="33%"><b>E-mail</b>:</td><td>';
        if(!empty($myrow['EMail'])) {
          echo '<a href="mailto:'.htmlspecialchars($myrow['EMail']).'">';
	  echo htmlspecialchars($myrow['EMail']).'</a></td>';
        } else
          echo 'None</td>';
      }
      echo "</tr>\n";

      /* occupation */
      if(isset($dispocc) || isset($dispwhere) || isset($dispwhat)) {
        if(isset($dispocc)) {
          echo '<tr><td width="33%"><b>Occupation</b>:</td>';
	  echo '<td>'.$myrow['oShortName'].'</td></tr>'."\n";
        }
        if(isset($dispwhere) && !empty($myrow['Occupation_Where'])) {
          echo '<tr><td width="33%"><b>Where (Occ.)</b></td>';
	  echo '<td colspan="3">'.htmlspecialchars($myrow['Occupation_Where']);
	  echo '</td></tr>'."\n";
	}
        if(isset($dispwhat) && !empty($myrow['Occupation_What'])) {
          echo '<tr><td width="33%"><b>What (Occ.)</b></td>';
	  echo '<td colspan="3">'.htmlspecialchars($myrow['Occupation_What']);
	  echo '</td></tr>'."\n";
	}
      }

      /* Address */
      if(isset($dispadd)) {
        if(!empty($myrow['Address_1'])) {
          echo '<tr><td width="33%"><b>Address (#1)</b></td>';
	  echo '<td colspan="3">'.htmlspecialchars($myrow['Address_1']);
	  echo '</td></tr>'."\n";
	}
        if(!empty($myrow['Address_2'])) {
          echo '<tr><td width="33%"><b>Address (#2)</b></td>';
	  echo '<td colspan="3">'.htmlspecialchars($myrow['Address_2']);
	  echo '</td></tr>'."\n";
	}
      }

      /* Phone */
      if(isset($dispphone)) {
        if(!empty($myrow['Phone'])) {
          echo '<tr><td width="33%"><b>Phone</b></td>';
	  echo '<td>'.htmlspecialchars($myrow['Phone']).'</td></tr>'."\n";
	}
      }

      /* Approval Status */
      if(isset($dispapprove)) {
        echo '<tr><td width="33%"><b>Approval Status</b></td><td>';
	approve_print($myrow['Approved']);
        echo '</td></tr>'."\n";
      }

      echo '</table><br />'."\n";
    }
  } while ($myrow = mysql_fetch_array($result));
} else {
  if($format=='CSV')
    page_header('$Id: list2.php3,v 1.8 2001/05/18 03:28:18 wakefield Exp $');
  echo '<br /><b>An entry with those criteria does not exist.</b><br />'."\n";
  if($format=='CSV')
    page_footer('Database Administration');
}

if($format=='Web')
  page_footer('Database Administration');
?>
