<?php
/*
 * Copyright (c) 2000-2001
 *   Peter Johnson <wakefield@users.sourceforge.net>.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the author nor the names of any co-contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL Peter Johnson OR
 * OTHER CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: find2.php3,v 1.12 2001/05/18 03:28:18 wakefield Exp $
 */

require('config.php3');
require('alumni.php3');

page_header('$Id: find2.php3,v 1.12 2001/05/18 03:28:18 wakefield Exp $');

$db = mysql_connect($dbhost, $dblogin, $dbpass);
mysql_select_db($dbname, $db);
?>
<font size="+1"><b><u>Find</u></b></font><br />
<form method="POST" action="find2.php3">
<table border="0" cellpadding="0" cellspacing="8"><tr>
<td></td>
<td><i>Criteria</i></td>
<td><i>Search for / in:</i></td>
<td colspan="2"><i>Display in output (if publicly available)</i></td>
</tr><tr>
<td><?php checkbox_input('chkname', isset($chkname)) ?></td><td>Name:</td>
<td><?php text_input('srchname', 0, 0, $srchname) ?></td>
<td><?php checkbox_input('dispname', isset($dispname)) ?>Name</td>
<td><?php checkbox_input('dispyear', isset($dispyear)) ?>School / Year</td>
</tr><tr>
<td><?php checkbox_input('chkschool', isset($chkschool)) ?></td><td>School:</td>
<td><?php school_select($db, 'school', $school) ?></td>
<td><?php checkbox_input('dispemail', isset($dispemail)) ?>E-mail</td>
<td><?php checkbox_input('dispocc', isset($dispocc)) ?>Occupation</td>
</tr><tr>
<td><?php checkbox_input('chkyear', isset($chkyear)) ?></td><td>Year Graduated:</td>
<td><?php text_input('srchyear', 0, 0, $srchyear) ?></td>
<td><?php checkbox_input('dispwhere', isset($dispwhere)) ?>Where (Occ.)</td>
<td><?php checkbox_input('dispwhat', isset($dispwhat)) ?>What (Occ.)</td>
</tr><tr>
<td><?php checkbox_input('chkocc', isset($chkocc)) ?></td><td>Occupation:</td>
<td><?php occtype_select($db, 'occtype', $occtype) ?></td>
<td><?php checkbox_input('dispadd', isset($dispadd)) ?>Address</td>
<td><?php checkbox_input('dispphone', isset($dispphone)) ?>Phone</td>
</tr><tr>
<td><?php checkbox_input('chkwhere', isset($chkwhere)) ?></td>
<td align="center"><i>Where?</i></td>
<td><?php text_input('srchwhere', 0, 0, $srchwhere) ?></td>
<td colspan="2"><i>Use the above to limit output (recommended).</i></td>
</tr><tr>
<td><?php checkbox_input('chkwhat', isset($chkwhat)) ?></td>
<td align="center"><i>What?</i></td>
<td><?php text_input('srchwhat', 0, 0, $srchwhat) ?></td>
<td colspan="2"><i>Usually phone and address info is not public.</i></td>
</tr><tr>
<td colspan="2"><?php hidden_input('startresults', 0) ?>
<?php hidden_input('numtotalresults', 0) ?>
<input type="submit" value="Search"></td>
<td colspan="3"><font size="-1">Show first <?php limitresults('numresults', $numresults) ?>
results.</font></td>
</tr></table>
</form>
<hr />
<?php

if ($numresults>50)
  $numresults = 50;

$anychecked = 0;

$query_string_data = 'SELECT Name_Last, Name_First';

if(isset($dispname))
  $query_string_data = $query_string_data . ', Name_Middle, Name_Nick';
if(isset($dispyear))
  $query_string_data = $query_string_data . ', LongName, Year';
if(isset($dispemail))
  $query_string_data = $query_string_data . ', Public_EMail, EMail';
if(isset($dispocc) || isset($dispwhere) || isset($dispwhat))
{
  $query_string_data = $query_string_data . ', Public_Occupation';
  if(isset($dispocc))
    $query_string_data = $query_string_data . ', Occupations.ShortName';
  if(isset($dispwhere))
    $query_string_data = $query_string_data . ', Occupation_Where';
  if(isset($dispwhat))
    $query_string_data = $query_string_data . ', Occupation_What';
}
if(isset($dispadd))
  $query_string_data = $query_string_data . ', Public_Address, Address_1, Address_2';
if(isset($dispphone))
  $query_string_data = $query_string_data . ', Public_Phone, Phone';

$query_string_data = $query_string_data . ' FROM Alumni LEFT JOIN Schools ON SchoolID = School LEFT JOIN Occupations ON OccupationID = Occupation WHERE ( ';

$query_string = ''; 
if (isset($chkname)) {
  $srchnames = explode(' ', addslashes($srchname));
  $query_string = $query_string . "(((Name_First LIKE '%$srchnames[0]%') OR (Name_Middle LIKE '%$srchnames[0]%') OR (Name_Last LIKE '%$srchnames[0]%') OR (Name_Nick LIKE '%$srchnames[0]%'))";
  for($i=1,$n=count($srchnames); $i<$n; $i++) {
    $query_string = $query_string . " AND ((Name_First LIKE '%$srchnames[$i]%') OR (Name_Middle LIKE '%$srchnames[$i]%') OR (Name_Last LIKE '%$srchnames[$i]%') OR (Name_Nick LIKE '%$srchnames[$i]%'))";
  }
  $query_string = $query_string . ')';
  $anychecked = 1;
}

if (isset($chkschool)) {
  if ($anychecked)
    $query_string = $query_string . ' AND ';
  $query_string = $query_string . '(School=' . intval($school) . ')';
  $anychecked = 1;
}

if (isset($chkyear)) {
  if ($anychecked)
    $query_string = $query_string . ' AND ';
  $srchyears = explode(' ', $srchyear);
  $query_string = $query_string . '((Year=' . intval($srchyears[0]) . ')';
  for($i=1,$n=count($srchyears); $i<$n; $i++) {
    $query_string = $query_string . ' OR (Year=' . intval($srchyears[$i]) . ')';
  }
  $query_string = $query_string . ')';
  $anychecked = 1;
}

if (isset($chkocc)) {
  if ($anychecked)
    $query_string = $query_string . ' AND ';
  $query_string = $query_string . '(Occupation=' . intval($occtype) . ')';
  $anychecked = 1;
}

if (isset($chkwhere)) {
  if ($anychecked)
    $query_string = $query_string . ' AND ';
  $srchwheres = explode(' ', addslashes($srchwhere));
  $query_string = $query_string . "((Occupation_Where LIKE '%$srchwheres[0]%')";
  for($i=1,$n=count($srchwheres); $i<$n; $i++) {
    $query_string = $query_string . " AND (Occupation_Where LIKE '%$srchwheres[$i]%')";
  }
  $query_string = $query_string . ')';
  $anychecked = 1;
}

if (isset($chkwhat)) {
  if ($anychecked)
    $query_string = $query_string . ' AND ';
  $srchwhats = explode(' ', addslashes($srchwhat));
  $query_string = $query_string . "((Occupation_What LIKE '%$srchwhats[0]%')";
  for($i=1,$n=count($srchwhats); $i<$n; $i++) {
    $query_string = $query_string . "((Occupation_What LIKE '%$srchwhats[$i]%')";
  }
  $query_string = $query_string . ')';
  $anychecked = 1;
}

if (isset($chkocc) || isset($chkwhere) || isset($chkwhat)) {
  $query_string = $query_string . ' AND (Public_Occupation=1)';
}

$query_string = $query_string . ' ) AND Alumni.Approved=1 ORDER BY Name_Last, Name_First, Year';

if ($anychecked && $numtotalresults == 0) {
  $result = mysql_query('SELECT COUNT(*) AS Total FROM Alumni WHERE ( ' . $query_string, $db);
  $myrow = mysql_fetch_array($result);
  $numtotalresults = $myrow['Total'];
}
$query_string = $query_string . ' LIMIT ' . intval($startresults) . ',' .
	intval($numresults);

$result = mysql_query($query_string_data . $query_string, $db);

if ($anychecked && $myrow = mysql_fetch_array($result)) {

  echo '<b>(';
  echo $startresults+1;
  echo ' - ';
  if ($startresults+$numresults > $numtotalresults)
    echo $numtotalresults;
  else
    echo $startresults+$numresults;
  echo ' of ';
  echo $numtotalresults;
  echo ')</b><br /><br />'."\n";

  if ($startresults != 0) {
    echo '<form method="POST" action="find2.php3">'."\n";
    if(isset($chkname))
      hidden_input('chkname', 1);
    if(isset($chkschool))
      hidden_input('chkschool', 1);
    if(isset($chkyear))
      hidden_input('chkyear', 1);
    if(isset($chkocc))
      hidden_input('chkocc', 1);
    if(isset($chkwhere))
      hidden_input('chkwhere', 1);
    if(isset($chkwhat))
      hidden_input('chkwhat', 1);
    if(isset($dispname))
      hidden_input('dispname', 1);
    if(isset($dispyear))
      hidden_input('dispyear', 1);
    if(isset($dispemail))
      hidden_input('dispemail', 1);
    if(isset($dispocc))
      hidden_input('dispocc', 1);
    if(isset($dispwhere))
      hidden_input('dispwhere', 1);
    if(isset($dispwhat))
      hidden_input('dispwhat', 1);
    if(isset($dispadd))
      hidden_input('dispadd', 1);
    if(isset($dispphone))
      hidden_input('dispphone', 1);
    hidden_input('srchname', $srchname);
    hidden_input('school', $school);
    hidden_input('srchyear', $srchyear);
    hidden_input('occtype', $occtype);
    hidden_input('srchwhere', $srchwhere);
    hidden_input('srchwhat', $srchwhat);
    hidden_input('startresults', $startresults-$numresults);
    hidden_input('numtotalresults', $numtotalresults);
    hidden_input('numresults', $numresults);
    echo '<input type="submit" value="Previous '.$numresults.' Results">'."\n";
    echo '</form>'."\n";
  }

  do {
    /* name */
    echo '<table border="1" width="95%">'."\n";
    echo '<tr><td width="50%"><b>'.htmlspecialchars($myrow['Name_Last']).', ';
    echo htmlspecialchars($myrow['Name_First']).'</b></td>';
    if(isset($dispname)) {
      echo '<td>'.htmlspecialchars($myrow['Name_Middle']).'</td>';
      if(!empty($myrow['Name_Nick']))
        echo '<td>A.K.A. '.htmlspecialchars($myrow['Name_Nick']).'</td>';
      else
        echo '<td></td>';
    }

    /* year / school */
    if(isset($dispyear)) {
      echo '<tr><td colspan="2"><b>School</b>: '.htmlspecialchars($myrow['LongName']).'</td>';
      echo '<td><b>Year</b>: '.$myrow['Year'].'</td>';
    }

    echo '</tr></table>'."\n";
    echo '<table border="1" width="95%">'."\n";

    /* email */
    if(isset($dispemail)) {
      echo '<td width="33%"><b>E-mail</b>:</td><td>';
      if(!$myrow['Public_EMail'])
        echo '<i>Private</i></td>';
      else if(!empty($myrow['EMail'])) {
        echo '<a href="mailto:'.htmlspecialchars($myrow['EMail']).'">';
	echo htmlspecialchars($myrow['EMail']).'</a></td>';
      } else
        echo 'None</td>';
    }
    echo '</tr>'."\n";

    /* occupation */
    if(isset($dispocc) || isset($dispwhere) || isset($dispwhat)) {
      if($myrow['Public_Occupation']) {
        if(isset($dispocc)) {
          echo '<tr><td width="33%"><b>Occupation</b>:</td>';
	  echo '<td>'.$myrow['ShortName'].'</td></tr>'."\n";
        }
        if(isset($dispwhere) && !empty($myrow['Occupation_Where'])) {
          echo '<tr><td width="33%"><b>Where (Occ.)</b></td>';
	  echo '<td colspan="3">'.htmlspecialchars($myrow['Occupation_Where']);
	  echo '</td></tr>'."\n";
	}
        if(isset($dispwhat) && !empty($myrow['Occupation_What'])) {
          echo '<tr><td width="33%"><b>What (Occ.)</b></td>';
	  echo '<td colspan="3">'.htmlspecialchars($myrow['Occupation_What']);
	  echo '</td></tr>'."\n";
	}
      } else {
        echo '<tr><td width="33%"><b>Occupation</b>:</td>';
	echo '<td colspan="3"><i>Private</i></td></tr>'."\n";
      }
    }

    /* Address */
    if(isset($dispadd)) {
      if($myrow['Public_Address']) {
        if(!empty($myrow['Address_1'])) {
          echo '<tr><td width="33%"><b>Address (#1)</b></td>';
	  echo '<td colspan="3">'.htmlspecialchars($myrow['Address_1']);
	  echo '</td></tr>'."\n";
	}
        if(!empty($myrow['Address_2'])) {
          echo '<tr><td width="33%"><b>Address (#2)</b></td>';
	  echo '<td colspan="3">'.htmlspecialchars($myrow['Address_2']);
	  echo '</td></tr>'."\n";
	}
      } else {
        echo '<tr><td width="33%"><b>Address</b>:</td>';
	echo '<td colspan="3"><i>Private</i></td></tr>'."\n";
      }
    }

    /* Phone */
    if(isset($dispphone)) {
      if($myrow['Public_Phone']) {
        if(!empty($myrow["Phone"])) {
          echo '<tr><td><b>Phone</b></td>';
	  echo '<td>'.htmlspecialchars($myrow['Phone']).'</td></tr>'."\n";
	}
      } else {
        echo '<tr><td><b>Phone</b>:</td>';
	echo '<td><i>Private</i></td></tr>'."\n";
      }
    }

    echo '</table><br />'."\n";
  } while ($myrow = mysql_fetch_array($result));
  if ($startresults+$numresults < $numtotalresults) {
    echo '<form method="POST" action="find2.php3">'."\n";
    if(isset($chkname))
      hidden_input('chkname', 1);
    if(isset($chkschool))
      hidden_input('chkschool', 1);
    if(isset($chkyear))
      hidden_input('chkyear', 1);
    if(isset($chkocc))
      hidden_input('chkocc', 1);
    if(isset($chkwhere))
      hidden_input('chkwhere', 1);
    if(isset($chkwhat))
      hidden_input('chkwhat', 1);
    if(isset($dispname))
      hidden_input('dispname', 1);
    if(isset($dispyear))
      hidden_input('dispyear', 1);
    if(isset($dispemail))
      hidden_input('dispemail', 1);
    if(isset($dispocc))
      hidden_input('dispocc', 1);
    if(isset($dispwhere))
      hidden_input('dispwhere', 1);
    if(isset($dispwhat))
      hidden_input('dispwhat', 1);
    if(isset($dispadd))
      hidden_input('dispadd', 1);
    if(isset($dispphone))
      hidden_input('dispphone', 1);
    hidden_input('srchname', $srchname);
    hidden_input('school', $school);
    hidden_input('srchyear', $srchyear);
    hidden_input('occtype', $occtype);
    hidden_input('srchwhere', $srchwhere);
    hidden_input('srchwhat', $srchwhat);
    hidden_input('startresults', $startresults+$numresults);
    hidden_input('numtotalresults', $numtotalresults);
    hidden_input('numresults', $numresults);
    echo '<input type="submit" value="Next '.$numresults.' Results">'."\n";
    echo '</form>'."\n";
  }
} else
  echo '<br /><b>An entry with those criteria does not exist.</b><br />'."\n";

page_footer('Main Alumni Database Page');
?>
